/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 4.0.2
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */
package com.herumi.mcl

import kotlin.jvm.JvmOverloads
import com.herumi.mcl.MclJNI
import kotlin.jvm.Synchronized
import com.herumi.mcl.Fp
import com.herumi.mcl.Fr
import com.herumi.mcl.G1
import com.herumi.mcl.G2
import com.herumi.mcl.GT
import com.herumi.mcl.MclConstants
import com.herumi.mcl.SWIGTYPE_p_bool
import com.herumi.mcl.ElgamalJNI
import com.herumi.mcl.CipherText

class PublicKey @JvmOverloads constructor(
    @field:Transient private var swigCPtr: Long = ElgamalJNI.new_PublicKey(),
    @field:Transient protected var swigCMemOwn: Boolean = true
) {
    protected fun finalize() {
        delete()
    }

    @Synchronized
    fun delete() {
        if (swigCPtr != 0L) {
            if (swigCMemOwn) {
                swigCMemOwn = false
                ElgamalJNI.delete_PublicKey(swigCPtr)
            }
            swigCPtr = 0
        }
    }

    fun toStr(): String? {
        return ElgamalJNI.PublicKey_toStr(swigCPtr, this)
    }

    override fun toString(): String {
        return ElgamalJNI.PublicKey_toString(swigCPtr, this)!!
    }

    fun fromStr(str: String?) {
        ElgamalJNI.PublicKey_fromStr(swigCPtr, this, str)
    }

    fun save(fileName: String?) {
        ElgamalJNI.PublicKey_save(swigCPtr, this, fileName)
    }

    fun load(fileName: String?) {
        ElgamalJNI.PublicKey_load(swigCPtr, this, fileName)
    }

    fun enc(c: CipherText?, m: Int) {
        ElgamalJNI.PublicKey_enc__SWIG_0(swigCPtr, this, CipherText.getCPtr(c), c, m)
    }

    fun enc(c: CipherText?, str: String?) {
        ElgamalJNI.PublicKey_enc__SWIG_1(swigCPtr, this, CipherText.getCPtr(c), c, str)
    }

    fun rerandomize(c: CipherText?) {
        ElgamalJNI.PublicKey_rerandomize(swigCPtr, this, CipherText.getCPtr(c), c)
    }

    fun add(c: CipherText?, m: Int) {
        ElgamalJNI.PublicKey_add__SWIG_0(swigCPtr, this, CipherText.getCPtr(c), c, m)
    }

    fun add(c: CipherText?, str: String?) {
        ElgamalJNI.PublicKey_add__SWIG_1(swigCPtr, this, CipherText.getCPtr(c), c, str)
    }

    companion object {
        protected fun getCPtr(obj: PublicKey?): Long {
            return obj?.swigCPtr ?: 0
        }
    }
}